import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;

import org.mozilla.javascript.Context;
import org.mozilla.javascript.ImporterTopLevel;
import org.mozilla.javascript.Scriptable;

import jp.ac.washi.quinte.api.CursorAction;
import jp.ac.washi.quinte.api.GameInfo;
import jp.ac.washi.quinte.api.Player;
import jp.ac.washi.quinte.api.SoldierAction;

public class Ȃ̃`[ extends Player {
    private final Player player;

    public Ȃ̃`[() {
        final String filePath = "player.js";
        final String variableName = "player";
        Context cx = Context.enter();
        Scriptable scope = new ImporterTopLevel(cx);
        Player player = null;
        try {
            Reader in = new FileReader(filePath);
            cx.evaluateReader(scope, in, filePath, 0, null);
            Object obj = scope.get(variableName, scope);
            player = (Player)(Context.jsToJava(obj, Player.class));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        this.player = player;
    }

    @Override
    public CursorAction nextCursorAction(GameInfo info) {
        CursorAction nextCursorAction = player.nextCursorAction(info);
        return nextCursorAction;
    }

    @Override
    public SoldierAction nextSoldierAction(GameInfo info) {
        return player.nextSoldierAction(info);
    }
}
